"Invalid query" (Error 500) message with MS SQL when displaying an issue from a list grouped and

sorted by fixed version
Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Jean-Philippe Lang % Done: 0%

Category: Issues Estimated time: 0.00 hour

Target version: 3.1.7   

Resolution: Fixed Affected version: 3.1.3

Description

Steps:

Prerequisite: this happens only with MS SQL

1. Filter a list of issues by grouping on the fixed version field, and showing the priority field

2. Click on the Fixed version field to sort on it in descending order, click on the priority field to also sort on that field

This should result in a query like this one for example

3. Click on one bug of the list

Result: Error 500, Invalid query. In the log, it is indicated that there are duplicated column names in an ORDER BY clause

Note: the issue also happens on MySQL, but MySQL does not consider duplicated sort columns as an error.

The issue happens in the feature to be able to navigate with arrows to the next or previous bug in the list we came from.

As the Fixed_version field implements a call back with its own sortable columns, this comes into the group_by_sort_order statement,

which then brings columns duplicated with the ones coming from the options.

Note that with a MySQL-backed Redmine site, the effect is that the order of the list can be incorrect in the previous/Next arrows on

the displayed bug.

See attached patch for a suggested fix.

Associated revisions

Revision 15852 - 2016-10-01 10:53 - Jean-Philippe Lang

Error with MS SQL when displaying an issue from a list grouped and sorted by fixed version (#23839).

Revision 15863 - 2016-10-01 16:34 - Jean-Philippe Lang

Test failures.

Revision 15864 - 2016-10-02 12:07 - Jean-Philippe Lang

Merged r15852 and r15863 (#23839).

Revision 15865 - 2016-10-02 12:10 - Jean-Philippe Lang

Merged r15852 and r15863 (#23839).

Revision 15866 - 2016-10-02 12:11 - Jean-Philippe Lang

Merged r15852 and r15863 (#23839).

History

#1 - 2016-09-15 15:11 - Toshi MARUYAMA

- Description updated

#2 - 2016-09-21 16:24 - Toshi MARUYAMA

- Target version set to 3.1.7

#3 - 2016-09-22 14:26 - Olivier Houdas

- File fix_duplicated_order_by_columns_v2.patch added
https://www.redmine.org/projects/redmine/issues?c%5B%5D=tracker&c%5B%5D=status&c%5B%5D=author&c%5B%5D=subject&c%5B%5D=fixed_version&c%5B%5D=due_date&c%5B%5D=priority&f%5B%5D=status_id&f%5B%5D=assigned_to_id&f%5B%5D=fixed_version_id&f%5B%5D=&group_by=fixed_version&op%5Bassigned_to_id%5D=%3D&op%5Bfixed_version_id%5D=%3D&op%5Bstatus_id%5D=o&set_filter=1&sort=priority%3Adesc%2Cfixed_version%3Adesc%2Cid%3Adesc&utf8=%E2%9C%93&v%5Bassigned_to_id%5D%5B%5D=1&v%5Bfixed_version_id%5D%5B%5D=121&v%5Bfixed_version_id%5D%5B%5D=122&v%5Bfixed_version_id%5D%5B%5D=119


It's nicer when testing for non-nil object before calling a method on it (map)... sorry for the bugged previous patch.

... and forgot to save after adding missing spaces on last line...

#4 - 2016-10-01 10:54 - Jean-Philippe Lang

- Status changed from New to Resolved

- Assignee set to Jean-Philippe Lang

- Resolution set to Fixed

Different fix applied in r15852 with a test. Thanks for pointing this out.

#5 - 2016-10-02 12:11 - Jean-Philippe Lang

- Status changed from Resolved to Closed

Files

fix_duplicated_order_by_columns.patch 999 Bytes 2016-09-15 Olivier Houdas

fix_duplicated_order_by_columns_v2.patch 1.19 KB 2016-09-22 Olivier Houdas

Powered by TCPDF (www.tcpdf.org)

2025-07-01 2/2

https://www.redmine.org/projects/redmine/repository/svn/revisions/15852
http://www.tcpdf.org

